"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ExternalIdentifier(ProtocolElement):
    """
    Identifier from a public database
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "database",
        "identifier",
        "version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.ExternalIdentifier": ga4gh_3_1_1.ExternalIdentifier,
        }

    __slots__ = [
        "database",
        "identifier",
        "version",
    ]

    def __init__(
        self,
        database,
        identifier,
        version,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.ExternalIdentifier model.

        :param database:
            The source of the identifier. (e.g. `Ensembl`)
        :type database: str
        :param identifier:
            The ID defined by the external database. (e.g. `ENST00000000000`)
        :type identifier: str
        :param version:
            The version of the object or the database (e.g. `78`)
        :type version: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
